/****************************************************************************/
//    copyright 2012 -2016  Chris Rizzitello <sithlord48@gmail.com>         //
//                                                                          //
//    This file is part of FF7tk                                            //
//                                                                          //
//    FF7tk is free software: you can redistribute it and/or modify         //
//    it under the terms of the GNU General Public License as published by  //
//    the Free Software Foundation, either version 3 of the License, or     //
//    (at your option) any later version.                                   //
//                                                                          //
//   FF7tk is distributed in the hope that it will be useful,               //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of        //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          //
//    GNU General Public License for more details.                          //
/****************************************************************************/

#ifndef FF7_SAVE_CONSTS_H
#define FF7_SAVE_CONSTS_H
#include <QByteArray>
/*~~~~~~~~~~~~~~~~~Unknown Tracking~~~~~~~~*/
static const int unknown_zmax = 46; //Number of "z" vars.
/*~~~~~~~~~~~~~~~~~~PC Save File ~~~~~~~~~~~~*/
static const int FF7_PC_SAVE_GAME_SIZE = 0xFE55;
static const int FF7_PC_SAVE_GAME_HEADER = 0x09;
static const int FF7_PC_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_PC_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_PC_SAVE_GAME_SLOT_HEADER = 0x00;
static const int FF7_PC_SAVE_GAME_SLOT_FOOTER = 0x0000;
static const int FF7_PC_SAVE_GAME_SLOT_SIZE = 0x10F4;
static const int FF7_PC_SAVE_GAME_SLOT_NUMBER = 15;
static const QByteArray PC_SAVE_GAME_FILE_ID = "\x71\x73";
static const quint8 PC_SAVE_GAME_FILE_HEADER[0x09] = {0x71,0x73,0x27,0x06,0x00,0x00,0x00,0x00,0x00}; //PC HEADER (for when we need to create one)

/*~~~~~~~~~~~~~~~~~~ Psx save file ~~~~~~~~~~~~~~~~*/
static const int FF7_PSX_SAVE_GAME_SIZE = 0x2000;
static const int FF7_PSX_SAVE_GAME_HEADER = 0x0000;
static const int FF7_PSX_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_PSX_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_PSX_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_PSX_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_PSX_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_PSX_SAVE_GAME_SLOT_NUMBER = 1;
static const QByteArray PSX_SAVE_GAME_FILE_ID = "\x53\x43\x11\x01\x82\x65\x82\x65\x82\x56\x81\x5E\x82\x72\x82\x60";

//BELOW 1/2 HEADER DATA FOR EACH PSX SAVE SLOT, (NOTE: last 256 bytes are 0x00, no region data in this section)

//Slot 01 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S01[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x50, 0x81,0x5E,0x82,0x4F, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x4F, 0x00,0x00,0x00,0x00, 0x62,0x75,0x31,0x30, 0x3A,0x00,0x00,0x00, 0x62,0x75,0x30,0x30, 0x3A,0x00,0x00,0x00, 0xA0,0x3B,0x1D,0x80, 0x8C,0x3C,0x1D,0x80,
 0x00,0x3F,0x1D,0x80, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1D,0x57, 0xDD,0x3E,0xBA,0x42, 0xB7,0x5E,0x53,0x5A, 0x38,0x2E,0xF8,0x1D, 0xF3,0x39,0xEE,0x59, 0xEC,0x71,0xB3,0x1D, 0x8E,0x39,0x87,0x7D, 0x08,0x31,0xFF,0x7F,
 0xFF,0x15,0x21,0x76, 0xF3,0xFF,0xFF,0xFF, 0xDF,0x5D,0x32,0x63, 0x66,0xDA,0xDD,0xFD, 0xDF,0x8A,0x66,0x77, 0x77,0x56,0xDD,0xFD, 0x4F,0x71,0x68,0x13, 0x7B,0x22,0xD5,0xFD,
 0x55,0x47,0x11,0x81, 0x3E,0x22,0xA2,0xFD, 0xDF,0x15,0x11,0xB3, 0x5E,0x72,0x52,0xF8, 0xAF,0x32,0x31,0x2B, 0x61,0xB2,0x77,0xFD, 0x8F,0x37,0x62,0x16, 0x61,0x73,0x67,0xF8,
 0xCF,0x67,0xBB,0x32, 0xB8,0x76,0xBB,0xFD, 0xBF,0x76,0xEB,0xB3, 0xEC,0xB7,0xCB,0xF8, 0x7F,0xB7,0x1B,0x31, 0x11,0xE7,0xD7,0xFD, 0x7F,0x5B,0x38,0x31, 0x11,0xEB,0xD8,0xFD,
 0xBF,0xAA,0xB7,0x11, 0x31,0xEB,0xDC,0xFD, 0xAF,0xDD,0xB8,0x18, 0xB3,0xCE,0xDE,0xFD, 0xDF,0xDD,0xBA,0xED, 0xCC,0xCC,0xDE,0xFD, 0xFF,0xFF,0xBF,0xEF, 0x5C,0xEC,0xEE,0xFF};

//Slot 02 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S02[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x51, 0x81,0x5E,0x82,0x58, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x58, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x50, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1B,0x63, 0x5A,0x42,0x72,0x62, 0x11,0x4A,0xB6,0x2D, 0xEC,0x69,0x56,0x21, 0x90,0x31,0x87,0x7D, 0x8C,0x39,0x29,0x2D, 0x0D,0x1D,0xE8,0x1C, 0xC7,0x14,0xFF,0x7F,
 0xFF,0xFF,0x1F,0x44, 0xAA,0xFF,0xFF,0xFF, 0x9F,0x99,0x36,0xC4, 0xED,0x9A,0x99,0xF9, 0x9F,0x99,0xFA,0x72, 0xC7,0x9C,0x99,0xF9, 0x9F,0x99,0xF1,0x51, 0x75,0xAC,0x99,0xF9,
 0x9F,0x39,0xFF,0x84, 0x77,0xDC,0x94,0xF9, 0x9F,0x39,0x82,0x8B, 0x57,0xCC,0x6A,0xF9, 0x9F,0x89,0xCC,0x21, 0x75,0xDD,0xEC,0xFB, 0x9F,0x49,0x82,0x11, 0xC7,0xEE,0xCD,0xDE,
 0x9F,0x89,0xBC,0xBD, 0xEC,0xEE,0x7E,0xDC, 0x9F,0xB9,0x38,0xD4, 0xEE,0xEE,0x7E,0xC7, 0x9F,0xDA,0x85,0x52, 0xED,0xEE,0xCE,0xC7, 0xAF,0xED,0xDC,0xCC, 0xEE,0xEE,0xCE,0x77,
 0xCF,0xED,0xBB,0xED, 0xEE,0xEE,0xCE,0x57, 0x84,0xEB,0xBB,0xEE, 0xEE,0xEE,0x7C,0x57, 0x58,0xD8,0xEE,0xEE, 0xCE,0x77,0x7C,0x25, 0x85,0xD8,0xCE,0xC7, 0x7C,0x75,0x5C,0x22};

//Slot 03 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S03[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x52, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x51, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x51, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1C,0x5F, 0x9B,0x4A,0x95,0x5E, 0x56,0x4A,0xBA,0x3D, 0x11,0x4E,0xD4,0x39, 0xEC,0x69,0xA9,0x79, 0xAF,0x41,0x74,0x21, 0x86,0x7D,0x4F,0x25, 0xEF,0x18,0xFF,0x7F,
 0xFF,0xFF,0x1F,0x44, 0xF1,0xFF,0xFF,0xFF, 0x8F,0x88,0x88,0x27, 0xA2,0xC8,0xCC,0xFC, 0x3F,0x77,0xA7,0x2B, 0x21,0xC4,0xCC,0xFC, 0x1F,0xE7,0x7E,0xED, 0xFF,0x61,0xCC,0xFC,
 0x1F,0xAB,0xEE,0xED, 0x1B,0x21,0xC6,0xFC, 0x2F,0xCB,0x2A,0x1F, 0x7B,0x25,0x87,0xFC, 0xBF,0xCD,0x16,0x1F, 0xBB,0x7B,0x74,0xF8, 0xDF,0xCD,0xF6,0x4F, 0xBE,0xBB,0x74,0xF8,
 0x8F,0xCD,0xA6,0xD1, 0xEE,0xBE,0xED,0xF6, 0xCF,0xC8,0x8B,0x11, 0xD8,0xEE,0xE7,0x15, 0xCF,0xCC,0xFE,0xF2, 0xDF,0xEB,0xED,0x5E, 0xCF,0xCC,0x1E,0xF1, 0x2F,0xEB,0xBE,0xBB,
 0xCF,0xCC,0xBE,0xF1, 0xB1,0xBE,0xEE,0x55, 0xCF,0xEC,0xEB,0x2B, 0xED,0xBE,0xEE,0xF4, 0xCF,0xEC,0xBB,0xBE, 0xB2,0xBE,0xEE,0x1A, 0xFF,0x1F,0xBE,0xFE, 0x51,0xEE,0xEE,0x34};

//Slot 04 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S04[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x53, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x51, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x52, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x9D,0x73, 0x5B,0x6B,0xF9,0x5E, 0xF6,0x6A,0xD5,0x62, 0x77,0x52,0x2E,0x6E, 0x31,0x4A,0x76,0x18, 0xC9,0x75,0x6A,0x49, 0x77,0x31,0x86,0x7D, 0x09,0x31,0xFF,0x7F,
 0xFF,0xFF,0x7F,0xA8, 0xFF,0xFF,0xFF,0xFF, 0xDF,0x77,0xB7,0xA6, 0xDD,0xDD,0xDD,0xFD, 0xAF,0x68,0xEC,0xAC, 0x7D,0xA7,0xAF,0xFA, 0xB7,0x3C,0xE8,0xBE, 0x7D,0x5F,0x7F,0xFF,
 0xEB,0xEE,0xEE,0xEE, 0xC9,0xF6,0x1F,0x55, 0xC6,0xEE,0x8B,0xEB, 0x6C,0x13,0xF1,0xFF, 0xBF,0xEE,0xF8,0xBE, 0xFE,0x1F,0x21,0x5A, 0xDF,0xBE,0xFE,0x51, 0xBE,0x47,0x55,0x24,
 0x9F,0xEB,0x38,0x6C, 0xF3,0xFF,0xFF,0x31, 0x8F,0xE8,0x6E,0x36, 0xF2,0x6F,0x11,0xF3, 0xF8,0x81,0x22,0x22, 0xFF,0x1F,0x62,0x36, 0x18,0x56,0xFF,0xFF, 0x21,0x12,0xF1,0x1F,
 0x8F,0xF5,0xF6,0x21, 0x12,0xFF,0xFF,0xFF, 0x5F,0xF1,0x11,0x13, 0xFF,0xFF,0xF1,0xFF, 0x14,0x33,0x33,0xF1, 0x1F,0x1F,0xF3,0xFF, 0x13,0xF3,0x16,0xFF, 0x3F,0x31,0xFF,0x1F};

//Slot 05 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S05[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x54, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x53, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1E,0x2E, 0x36,0x3E,0xD7,0x2D, 0x5C,0x21,0xCC,0x65, 0xB0,0x49,0x8C,0x10, 0xAE,0x51,0x9C,0x73, 0x87,0x7D,0x35,0x1D, 0x11,0x29,0x0D,0x25, 0xB0,0x14,0xFF,0x7F,
 0xFF,0x99,0x99,0xCE, 0x89,0xCE,0xEE,0xBC, 0xAF,0xEC,0xCE,0xEE, 0xEC,0xC7,0xBE,0x4B, 0xAF,0xAA,0xEE,0xE7, 0x7E,0xE7,0x4B,0xE4, 0xAF,0xDC,0xCD,0x77, 0x7E,0xEE,0xEE,0xEE,
 0xCF,0xEE,0xEE,0x7E, 0xEE,0xBE,0xBB,0xBE, 0xAF,0xAA,0xDC,0xEE, 0xBE,0x44,0x7D,0x3B, 0xAF,0xAA,0xAA,0xBB, 0x11,0x14,0x7D,0x13, 0xAF,0xAA,0xEA,0x44, 0x43,0x11,0x73,0x11,
 0xAF,0xAA,0xD5,0xDE, 0x39,0x11,0xD4,0x33, 0xAF,0x5A,0xCC,0x14, 0x43,0xEE,0xDB,0x95, 0xAF,0xDA,0x47,0x41, 0x4B,0x41,0xDE,0xFA, 0xAF,0x6A,0x11,0xB1, 0xE8,0xBE,0x8E,0xFA,
 0xAF,0xAA,0x13,0x64, 0xA2,0xC5,0x2D,0xFA, 0xAF,0xAA,0x35,0x83, 0xAC,0xAA,0x85,0xFA, 0xAF,0xAA,0xAA,0x8A, 0xAC,0xAA,0xEA,0xFA, 0xFF,0xFF,0xFF,0x9F, 0xF9,0xFF,0xE9,0xF5};

//Slot 06 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S06[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x55, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x54, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x3C,0x5B, 0x3E,0x4F,0xDD,0x36, 0x99,0x46,0x1C,0x22, 0x30,0x62,0x8D,0x31, 0x32,0x46,0xD0,0x35, 0xCB,0x59,0xA8,0x79, 0x86,0x7D,0x71,0x21, 0x4B,0x29,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x46, 0x64,0xF6,0xFF,0xFF, 0xCF,0xCC,0x6C,0x21, 0x32,0x64,0xCC,0xFC, 0xCF,0xCC,0x16,0xFF, 0xFF,0x22,0xC6,0xFC, 0xCF,0xAC,0x23,0xF1, 0x2F,0x23,0x63,0xFC,
 0xCF,0x84,0xDD,0x88, 0x34,0x54,0x35,0xFA, 0xAF,0x84,0xEE,0x44, 0xD8,0x49,0x55,0xF6, 0xAF,0xEE,0xED,0x48, 0xE8,0x18,0x54,0xF4, 0xCF,0xDA,0x77,0xED, 0xEE,0x8E,0x58,0xF5,
 0xCF,0x8C,0xDD,0xDE, 0x44,0x88,0xD8,0xF6, 0xCF,0x8C,0x22,0x44, 0x31,0x43,0xAA,0xFC, 0xCF,0xAC,0x44,0xF1, 0x52,0x45,0xAA,0xFC, 0xCF,0xAC,0x48,0x48, 0xD5,0xDD,0xA8,0xFC,
 0xAF,0x48,0xF2,0x58, 0x7D,0x77,0xEE,0xF7, 0xAF,0xC4,0x46,0x42, 0x77,0xEE,0xEE,0xF7, 0xCF,0xCC,0x8A,0xE8, 0xEE,0xEE,0x7E,0xA7, 0xFF,0xAF,0xEE,0xEE, 0x77,0xEE,0x7E,0xA8};

//Slot 07 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S07[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x56, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x55, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x7D,0x6B, 0x18,0x63,0xDC,0x4A, 0x77,0x4A,0x51,0x5E, 0x32,0x46,0xCC,0x65, 0xA9,0x75,0x86,0x7D, 0x8D,0x31,0x69,0x49, 0x29,0x25,0x28,0x25, 0xE7,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xFF, 0xFF,0xFF,0xFF,0xFF, 0x8F,0x88,0xA8,0x65, 0xA6,0xAC,0x88,0xF8, 0x8F,0x88,0xDA,0xAA, 0xEE,0xCC,0x88,0xF8, 0x8F,0xA8,0xAE,0x66, 0xEA,0xAA,0xAA,0xF8,
 0x8F,0xD8,0xAE,0x6A, 0x46,0xEA,0xAE,0xF8, 0x8F,0xE8,0xEE,0xAC, 0xF3,0xE4,0xAC,0xF8, 0x8F,0xEA,0xAA,0xA6, 0x16,0xE2,0x66,0xFA, 0x8F,0xEA,0x33,0x41, 0x2C,0xE6,0x22,0xFA,
 0x8F,0xEA,0x31,0x1F, 0xF2,0xA6,0x22,0xFA, 0x8F,0xEA,0x34,0xF1, 0xFF,0x42,0x16,0xF5, 0x8F,0xEA,0x3A,0xFF, 0x1F,0xDA,0x2A,0xF2, 0x8F,0xEA,0x4E,0x22, 0x11,0x2E,0x6C,0xF6,
 0x8F,0xEA,0xEE,0x3E, 0x1F,0xFE,0xAE,0x66, 0x8F,0xE8,0xEE,0x1A, 0xFF,0xEE,0xAE,0xAA, 0x8F,0xEA,0xEE,0x14, 0xFF,0xE6,0xEE,0xAC, 0xFF,0xE5,0x6E,0x13, 0xFF,0xC1,0xEE,0xCE};

//Slot 08 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S08[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x57, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x56, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xD8,0x56, 0x3D,0x46,0xDC,0x4A, 0xDC,0x3D,0x0E,0x52, 0xB5,0x39,0xC9,0x71, 0xAE,0x35,0x87,0x7D, 0x17,0x21,0x6A,0x35, 0xF3,0x20,0xEF,0x1C, 0xE8,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x1F, 0x11,0xFF,0xFF,0xFF, 0x9F,0x99,0xB7,0x8B, 0xEB,0xBE,0x99,0xF9, 0x9F,0x79,0xEB,0x18, 0x81,0xEE,0x9B,0xF9, 0x9F,0xB7,0xEE,0x8E, 0xF5,0xE8,0xBE,0xF9,
 0x7F,0xEB,0xEE,0xEE, 0x5B,0xE8,0xEE,0xF9, 0xBF,0xDD,0xDC,0xDD, 0xEE,0xEE,0xEE,0xFB, 0xBF,0xCD,0xAA,0x4A, 0xEC,0xEC,0xEE,0xFB, 0xBF,0xCD,0xEE,0xAC, 0xEA,0xED,0xEE,0xFB,
 0xE1,0xDD,0xEB,0x4A, 0xEC,0xEC,0xEE,0xFB, 0xEE,0x8E,0xEB,0xDE, 0xDE,0xEE,0xEE,0xFB, 0xED,0x6E,0xEB,0xF3, 0x33,0xEE,0xEE,0xFE, 0xDD,0x8C,0xCE,0xFF, 0x3F,0xEE,0xEE,0xFE,
 0xCC,0x8A,0xCE,0x36, 0xE6,0xDE,0xEE,0xFE, 0xAA,0x64,0xAE,0xA4, 0xDD,0xCD,0xBE,0xFE, 0x46,0x62,0xAD,0x12, 0x1F,0xC1,0xBE,0x1C, 0x24,0x64,0x44,0x44, 0xAA,0xCC,0xEE,0xCA};

//Slot 09 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S09[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x58, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x57, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x3E,0x4F, 0xDC,0x4E,0x13,0x42, 0x52,0x4A,0xB0,0x35, 0x4D,0x29,0xB5,0x56, 0xA9,0x75,0xA8,0x14, 0xA7,0x7D,0xC7,0x29, 0x89,0x4D,0xEA,0x1C, 0x66,0x1D,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x44, 0x44,0xFF,0xFF,0xFF, 0xAF,0xAA,0x6C,0x55, 0xD6,0xCD,0xAA,0xFA, 0xAF,0xCA,0x35,0x53, 0x65,0xDD,0xAC,0xFA, 0xAF,0x5C,0x33,0x35, 0x55,0xD6,0xAD,0xFA,
 0xAF,0x35,0x53,0x33, 0x35,0xD6,0xC9,0xFA, 0xAF,0x35,0x53,0x53, 0x56,0x66,0xD9,0xFA, 0xAF,0x36,0x63,0x65, 0x69,0x67,0xDD,0xFA, 0xAF,0x5D,0x93,0x96, 0x49,0x94,0xDD,0xFA,
 0xAF,0x6D,0x65,0x67, 0x21,0x61,0x6D,0xFA, 0xAF,0xDC,0x56,0x12, 0x21,0x32,0xC6,0xFA, 0xAF,0xEC,0x6D,0x12, 0x31,0x32,0xAC,0xFA, 0xAF,0xBE,0xD9,0x23, 0x74,0xD3,0xAC,0xFA,
 0xCF,0xEE,0xE9,0x3D, 0x32,0x9D,0xC4,0xFA, 0xEF,0xEB,0xE8,0x6B, 0xDD,0x99,0xB7,0xFC, 0xEC,0x3E,0xE2,0xEB, 0xEE,0xEE,0x47,0xBB, 0xBE,0x13,0xBE,0xEB, 0xEB,0x4E,0x47,0xB4};

//Slot 10 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S10[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x4F, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x58, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xFC,0x52, 0x7B,0x36,0x74,0x4E, 0x72,0x5E,0x15,0x32, 0xF2,0x39,0x0C,0x6E, 0xC9,0x79,0xA8,0x7D, 0x9C,0x73,0x8F,0x29, 0xAD,0x35,0x86,0x7D, 0x29,0x29,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xAA, 0xAA,0xFF,0xFF,0xFF, 0xDF,0xDD,0x79,0x53, 0xB6,0xD8,0xDD,0xFD, 0xDF,0x9D,0x24,0x22, 0x55,0x8B,0xDD,0xFD, 0xDF,0x4D,0x21,0x22, 0x22,0xB5,0xD8,0xFD,
 0xDF,0x29,0x52,0x5B, 0xB5,0xBB,0x9C,0xFD, 0xDF,0x29,0x21,0x53, 0x26,0xB2,0x8B,0xFD, 0xDF,0x39,0xFF,0xFF, 0x1F,0x52,0x52,0xFD, 0xDF,0x39,0xF1,0xFF, 0x1F,0x62,0x2B,0xFD,
 0xDF,0x67,0xE6,0x16, 0xE3,0x5C,0x2B,0xFD, 0xDF,0xC8,0xFF,0xF1, 0x12,0x52,0x57,0xFD, 0xDF,0xCD,0xF1,0xFF, 0xF2,0x72,0x7D,0xFD, 0xDF,0xDD,0xFC,0x1F, 0x12,0x76,0x9D,0xFD,
 0xDF,0x9D,0xCE,0xFF, 0x51,0xCE,0xD9,0xFD, 0xDF,0x6D,0xEE,0x3C, 0xE5,0xEE,0x96,0xFD, 0xDA,0xC6,0xCE,0xEE, 0xEE,0xEE,0x6C,0xA9, 0x11,0xC6,0xEE,0xCC, 0xEC,0xEE,0x6C,0x16};

//Slot 11 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S11[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x50, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x4F, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xBE,0x67, 0xFB,0x52,0x79,0x3A, 0x31,0x4A,0x14,0x36, 0xFF,0x7F,0x83,0x10, 0xD0,0x35,0x87,0x7D, 0x19,0x6B,0x6A,0x35, 0x2A,0x25,0x27,0x35, 0xE5,0x24,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xFF, 0xFF,0xFF,0xFF,0xFF, 0x9F,0x99,0x99,0xBB, 0xBC,0x99,0x99,0xF9, 0x9F,0x99,0xB9,0xEC, 0xEE,0x9E,0x99,0xF9, 0x9F,0x99,0xCB,0xCC, 0xCE,0xBE,0x99,0xF9,
 0x9F,0x99,0x2B,0x53, 0x35,0xC5,0x99,0xF9, 0x9F,0x99,0x18,0x11, 0x11,0x82,0x99,0xF9, 0x9F,0x99,0x14,0x11, 0x11,0x83,0x99,0xF9, 0x9F,0x49,0x84,0x2B, 0x82,0x5B,0x94,0xF9,
 0x9F,0x89,0x22,0x12, 0x33,0x53,0x9B,0xF9, 0x9F,0xB9,0x1C,0x11, 0x13,0xC2,0x9E,0xF9, 0x9F,0xE9,0x47,0x11, 0x23,0xE5,0xBE,0xF9, 0x9F,0x7B,0xC7,0x22, 0x52,0xEB,0xE7,0xF9,
 0xBA,0x77,0x87,0x54, 0xC5,0xB4,0x77,0xAB, 0x7B,0x77,0x8E,0xC1, 0x4C,0xE4,0x7E,0xBD, 0xEE,0xE7,0xBE,0xE2, 0x8E,0xEB,0x7D,0xDE, 0xDE,0x7E,0xEE,0xC8, 0x8C,0xDE,0xE7,0xEE};

//Slot 12 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S12[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x51, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x50, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xBF,0x6F, 0x7C,0x6B,0x1B,0x5B, 0xBB,0x3E,0xD7,0x4E, 0x97,0x3A,0x31,0x56, 0x14,0x32,0x9C,0x73, 0xED,0x59,0xD1,0x2D, 0x09,0x21,0x86,0x7D, 0x8D,0x35,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x99, 0xF9,0xFF,0xFF,0xFF, 0xDF,0xDD,0x5A,0x65, 0x76,0xDA,0xDD,0xFD, 0xDF,0xAD,0x55,0x66, 0x68,0xA5,0xDD,0xFD, 0xDF,0x5D,0x63,0x86, 0x66,0x54,0xDD,0xFD,
 0xDF,0x3A,0x86,0x36, 0x41,0x48,0xDA,0xFD, 0xDF,0x57,0x68,0x12, 0x41,0x68,0xDA,0xFD, 0xDF,0x67,0x3B,0x81, 0x4B,0x88,0xD7,0xFD, 0xDF,0x67,0x3B,0x61, 0x8C,0xB8,0xDA,0xFD,
 0xDF,0x67,0x13,0x11, 0x44,0xB8,0xDD,0xFD, 0xDF,0x6A,0x21,0x14, 0x43,0xEB,0xDD,0xFD, 0xDF,0x7A,0x25,0x25, 0xB4,0xDE,0xDD,0xFD, 0xDF,0x7D,0x5B,0x63, 0xBB,0xDD,0xDD,0xFD,
 0xDF,0xAD,0xD7,0x6A, 0x84,0xDE,0xDD,0xFD, 0xDF,0xDD,0xD7,0x2E, 0xE3,0xEC,0xDD,0xFD, 0xDF,0xDD,0xEA,0x5C, 0xCE,0xCC,0xDE,0x9D, 0xFF,0x9F,0xCE,0xEC, 0xCC,0xCC,0xEC,0x9A};

//Slot 13 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S13[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x52, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x51, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5A,0x6B, 0x1F,0x4B,0xFE,0x42, 0xF9,0x5E,0xB8,0x4E, 0x36,0x36,0x31,0x52, 0x9C,0x73,0xC4,0x24, 0x8B,0x45,0xAE,0x35, 0x86,0x7D,0x4D,0x21, 0x06,0x2D,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x88, 0x88,0xFF,0xFF,0xFF, 0xCF,0xCC,0xAC,0x77, 0x77,0xCA,0xCC,0xFC, 0xCF,0xCC,0x5A,0x22, 0x33,0xC5,0xCC,0xFC, 0xCF,0xCC,0x25,0x32, 0x33,0x73,0xCC,0xFC,
 0xCF,0xCC,0x25,0x33, 0x33,0x73,0xCC,0xFC, 0xCF,0xCC,0x25,0x33, 0x23,0xB3,0xCC,0xFC, 0xCF,0xCC,0x67,0xBB, 0xBB,0xB6,0xCC,0xFC, 0xCF,0xAC,0xEB,0xDE, 0xED,0xDE,0xC7,0xFC,
 0xCF,0x7C,0x65,0x5B, 0x6B,0xDB,0xC7,0xFC, 0xCF,0x7C,0x37,0x22, 0x26,0xB6,0xCC,0xFC, 0xCF,0xCC,0x67,0x52, 0x66,0xCD,0xCC,0xFC, 0xCF,0xCC,0x6A,0x33, 0x63,0xAE,0xCC,0xFC,
 0xCF,0xAC,0x59,0xDB, 0xED,0xEB,0xCA,0xFC, 0xC8,0x9A,0x1E,0xB4, 0xBB,0xE7,0xA9,0x8C, 0xEA,0x99,0x7E,0xE1, 0x4E,0xE7,0xE9,0xAE, 0xEE,0xE9,0xAE,0xB4, 0x7E,0xEB,0xE9,0xEE};

//Slot 14 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S14[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x53, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x52, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5C,0x67, 0xB9,0x4A,0x06,0x2D, 0x12,0x3A,0xEE,0x61, 0xD1,0x49,0xCA,0x6D, 0xA8,0x7D,0x90,0x31, 0x86,0x7D,0xD5,0x1C, 0x08,0x25,0xD1,0x1C, 0xEB,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x11, 0x11,0xFF,0xFF,0xFF, 0xAF,0xAA,0xDA,0xDB, 0xBD,0xA9,0xAA,0xFA, 0xAF,0xBA,0xBB,0xBD, 0xBD,0x9D,0xAA,0xFA, 0xAF,0xDA,0xBD,0xBB, 0xDD,0xDD,0xA5,0xFA,
 0xAF,0x9A,0xDD,0xBB, 0xED,0xDD,0x59,0xFA, 0xAF,0xBA,0xDD,0x9C, 0xEC,0xC9,0xDD,0xFA, 0xAF,0xBA,0xEE,0xCE, 0x9E,0xEE,0xDD,0xFA, 0xAF,0xBA,0x9E,0x12, 0x11,0xE2,0xB9,0xFA,
 0xAF,0x9A,0x44,0x44, 0x22,0xE4,0xB5,0xFA, 0x81,0x66,0x49,0xC9, 0x24,0x9C,0xDA,0xFA, 0xB6,0xDB,0x4C,0xF1, 0x21,0xE9,0xDA,0xFA, 0xDB,0x36,0x94,0x12, 0x21,0xE9,0x9A,0xFA,
 0x71,0x33,0x41,0x29, 0x91,0xAE,0xAA,0xFA, 0x35,0x93,0x1F,0x9E, 0xE9,0x33,0xAA,0xFA, 0x33,0x93,0x1F,0x44, 0x1E,0x39,0x83,0xFA, 0x33,0x93,0x11,0x24, 0x19,0x39,0x13,0xFF};

//Slot 15 Header
static const quint8 PSX_SAVE_GAME_FILE_HEADER_S15[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x54, 0x81,0x5E,0x82,0x58, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x58, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x53, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5C,0x67, 0x37,0x67,0xB9,0x4E, 0xB2,0x5A,0x37,0x3A, 0x34,0x42,0x50,0x4E, 0xCF,0x39,0xA8,0x71, 0xAA,0x59,0xAB,0x45, 0xAC,0x35,0x86,0x7D, 0x29,0x25,0xFF,0x7F,
 0x1F,0x77,0xEB,0xEE, 0xF2,0x21,0x42,0xEE, 0x9F,0xB7,0xBE,0xE8, 0xFC,0x2F,0x22,0xB4, 0x9F,0xE7,0xEE,0x68, 0x46,0x2F,0x24,0x42, 0x9F,0xE4,0x39,0xF1, 0x63,0x42,0x24,0x74,
 0x9F,0xE2,0x19,0xFF, 0x61,0x44,0x47,0x44, 0x9F,0xE1,0x19,0xFF, 0x83,0x47,0xCC,0x77, 0xDF,0xE2,0xBD,0x51, 0x8E,0x78,0x6C,0x8C, 0xDF,0xE4,0xAD,0x13, 0x63,0x87,0x68,0xEC,
 0xDF,0xE4,0x9D,0xF1, 0xFF,0xC7,0x68,0xEC, 0xDF,0xB7,0xDD,0x14, 0xFF,0xE7,0x55,0xCE, 0xDF,0xBA,0xDD,0x6B, 0xF1,0xE6,0x65,0xCE, 0xDF,0xAD,0x9A,0x4E, 0xF1,0xE3,0xE5,0xCC,
 0xDF,0x9D,0xEE,0xEE, 0x11,0xE5,0xE3,0xCC, 0xDF,0xDD,0xE8,0xEE, 0xEE,0xE5,0xE1,0x8C, 0xDF,0xDD,0x8C,0xEE, 0xEE,0x45,0xE1,0x8C, 0xFF,0xFF,0xC1,0xE8, 0xEE,0x13,0xE3,0x78};

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PSV SAVE INFO~~~~~~~~~~~~~~~~~~~~~~~~~*/
static const int FF7_PSV_SAVE_GAME_SIZE = 0x2084;
static const int FF7_PSV_SAVE_GAME_HEADER = 0x0084;
static const int FF7_PSV_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_PSV_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_PSV_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_PSV_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_PSV_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_PSV_SAVE_GAME_SLOT_NUMBER = 1;
static const QByteArray PSV_SAVE_GAME_FILE_ID = "\x00\x56\x53\x50";

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Mem Card Format~~~~~~~~~~~~~~~~~~~*/
static const int FF7_MC_SAVE_GAME_SIZE = 0x20000;
static const int FF7_MC_SAVE_GAME_HEADER = 0x2000;
static const int FF7_MC_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_MC_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_MC_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_MC_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_MC_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_MC_SAVE_GAME_SLOT_NUMBER = 15;
static const QByteArray MC_SAVE_GAME_FILE_ID = "\x4D\x43";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PSP SAVE FORMAT~~~~~~~~~~~~~~~~~~~*/
static const int FF7_PSP_SAVE_GAME_SIZE = 0x20080;
static const int FF7_PSP_SAVE_GAME_HEADER = 0x2080;
static const int FF7_PSP_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_PSP_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_PSP_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_PSP_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_PSP_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_PSP_SAVE_GAME_SLOT_NUMBER = 15;
static const QByteArray PSP_SAVE_GAME_FILE_ID = "\x00\x50\x4D\x56";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~VGM SAVE FORMAT~~~~~~~~~~~~~~~~~~~~*/
static const int FF7_VGS_SAVE_GAME_SIZE = 0x20040;
static const int FF7_VGS_SAVE_GAME_HEADER = 0x2040;
static const int FF7_VGS_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_VGS_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_VGS_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_VGS_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_VGS_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_VGS_SAVE_GAME_SLOT_NUMBER = 15;
static const QByteArray VGS_SAVE_GAME_FILE_ID = "\x56\x67\x73\x4D";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~DEX SAVE FORMAT~~~~~~~~~~~~~~~~~~~~*/
static const int FF7_DEX_SAVE_GAME_SIZE = 0x20F40;
static const int FF7_DEX_SAVE_GAME_HEADER = 0x2F40;
static const int FF7_DEX_SAVE_GAME_FOOTER = 0x0000;
static const int FF7_DEX_SAVE_GAME_DATA_SIZE = 0x10F4;
static const int FF7_DEX_SAVE_GAME_SLOT_HEADER = 0x0200;
static const int FF7_DEX_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
static const int FF7_DEX_SAVE_GAME_SLOT_SIZE = 0x2000;
static const int FF7_DEX_SAVE_GAME_SLOT_NUMBER = 15;
static const QByteArray DEX_SAVE_GAME_FILE_ID= "\x31\x32\x33\x2D\x34\x35\x36\x2D\x53\x54\x44";
/*~~~~~~~~~~~~~~~~raw default save game~~~~~~~~~~~~~~~~*/
static const quint8 default_save[0x10F4] =
{
	0xCD, 0x2A, 0x00, 0x00, 0x01, 0x00, 0xFF, 0xFF, 0x25, 0x58, 0x0D, 0x33, 0x2F, 0x2C, 0x24, 0x29,
	0x25, 0x32, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x00, 0x40, 0x01, 0x36, 0x00, 0x39, 0x00,
	0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4C, 0x41, 0x54, 0x46, 0x4F, 0x52, 0x4D,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x58, 0xB0, 0x00, 0x00, 0x50, 0x00, 0x00,
	0x80, 0x00, 0x00, 0x20, 0x00, 0x06, 0x14, 0x10, 0x13, 0x11, 0x06, 0x0E, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x01, 0x80, 0x25, 0x58, 0x0D, 0x33, 0x2F, 0x2C, 0x24, 0x29, 0x25, 0x32, 0xFF, 0xFF,
	0x00, 0x00, 0xFF, 0x00, 0xFF, 0x1D, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x3A, 0x01, 0x3A, 0x01, 0x36, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3A, 0x01, 0x36, 0x00,
	0x62, 0x02, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00, 0x32, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0x23, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0F, 0x0D, 0x0B, 0x09, 0x05, 0x0D,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x22, 0x41, 0x52, 0x52, 0x45, 0x54, 0xFF, 0xFF,
	0x00, 0xFF, 0xFF, 0xFF, 0x20, 0x00, 0xFF, 0x00, 0xFF, 0x1B, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0xDE, 0x00, 0xDE, 0x00, 0x0F, 0x00, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xDE, 0x00, 0x0F, 0x00, 0x0A, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x0B, 0x0B,
	0x0B, 0x0A, 0x07, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x19, 0x34, 0x49, 0x46, 0x41,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x00, 0xFF, 0x00, 0xFF, 0x00, 0x01, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDB, 0x00, 0xDB, 0x00, 0x10, 0x00, 0x10, 0x00,
	0x00, 0x00, 0x00, 0x00, 0xDB, 0x00, 0x10, 0x00, 0x08, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
	0x03, 0x01, 0x0A, 0x0B, 0x0D, 0x0E, 0x05, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x14,
	0x21, 0x45, 0x52, 0x49, 0x54, 0x48, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x3E, 0x00, 0xFF, 0x00,
	0xFE, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB1, 0x00, 0xB1, 0x00,
	0x17, 0x00, 0x17, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0x00, 0x00, 0x00, 0x00, 0x04, 0x01, 0x0A, 0x0C, 0x0B, 0x0A, 0x0A, 0x0E, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x01, 0x6A, 0x32, 0x45, 0x44, 0x00, 0x38, 0x29, 0x29, 0x29, 0xFF, 0xFF, 0xFF, 0xFF,
	0x30, 0x03, 0xFF, 0x00, 0xFF, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xDD, 0x00, 0xDD, 0x00, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0x0C, 0x00, 0x00, 0x00, 0x31, 0xE8, 0x03, 0x00, 0x17, 0xE8, 0x03, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0x25, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x05, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x2B, 0x39, 0x55, 0x46, 0x46, 0x49, 0x45, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0x57, 0x04, 0xFF, 0x00, 0xFF, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x64, 0x00, 0x64, 0x00, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x27, 0x2C, 0x01, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x09, 0x01, 0x0C, 0x0C,
	0x0B, 0x0A, 0x06, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x23, 0x4C, 0x4F, 0x55,
	0x44, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x00, 0x01, 0x00, 0x00, 0xFE, 0x07, 0x01, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8C, 0x00, 0x8C, 0x00, 0x04, 0x00, 0x04, 0x00,
	0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x0C, 0x00, 0x00, 0x00, 0x0A, 0x00, 0x00, 0x00,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x74, 0x00, 0x00, 0x00,
	0x0A, 0x32, 0x55, 0x48, 0x44, 0x46, 0x41, 0x2E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
	0x33, 0x45, 0x50, 0x48, 0x49, 0x52, 0x4F, 0x54, 0x48, 0xFF, 0xFF, 0xFF, 0x7F, 0x06, 0x08, 0x00,
	0xFF, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x0F,
	0xCC, 0x01, 0xCC, 0x01, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xB6, 0xE3, 0x04, 0x00,
	0x37, 0xFF, 0xFF, 0xFF, 0x35, 0xFF, 0xFF, 0xFF, 0x33, 0xFF, 0xFF, 0xFF, 0x17, 0xFF, 0xFF, 0xFF,
	0x31, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0x32, 0xFF, 0xFF, 0xFF, 0x17, 0xFF, 0xFF, 0xFF, 0x34, 0xFF, 0xFF, 0xFF, 0x17, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xAA, 0xE8, 0x00, 0x00, 0x08, 0x01, 0x0C, 0x0C, 0x0B, 0x0A, 0x06, 0x0E, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x01, 0x3F, 0x23, 0x49, 0x44, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0x49, 0x06, 0xFF, 0x00, 0xFF, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xDF, 0x00, 0xDF, 0x00, 0x0F, 0x00, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,
	0x12, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x00, 0x06, 0x03, 0x02,
	0x07, 0x02, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF0, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB3, 0x4B, 0x00, 0x00, 0xB3, 0x4B, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x00, 0x47, 0x0E, 0x28, 0x6B, 0x19, 0x00,
	0x60, 0x40, 0x0D, 0x00, 0x00, 0x00, 0x00, 0x32, 0x1E, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x03, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0xFB, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x64, 0x64, 0x64, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x14, 0x00, 0x00, 0x00, 0xE2, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4C, 0x41, 0x54,
	0x46, 0x4F, 0x52, 0x4D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x41, 0x00, 0x00, 0x01, 0x02, 0x03,
	0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, 0x80, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00
};
#endif // FF7_SAVE_CONSTS_H
